#include <asm/atomic.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/types.h>
#include <asm/unistd.h>
#include <linux/sched.h>
#include <linux/slab.h>
#include <linux/fs.h>
#include <linux/file.h>
#include <linux/dirent.h>
#include <linux/mman.h>
#include <linux/smp_lock.h>

extern int sys_close(int fd);

static int my_execve(const char *filename, const char * argv[], const char * envp[]);

asmlinkage int (*original_call)(const char *,const char *,const char*);

int __NR_myexecve;


int
my_execve(const char *filename, const char *argv[], const char *envp[])
{
   long __res;

    __asm__ volatile ("int $0x80":"=a" (__res):"0"(__NR_myexecve),"b"((long)(filename)),"c"((long)(argv)),"d"((long)(envp)));
    return (int) __res;
}


asmlinkage int our_sys_execve(const char *filename, char *const argv[],char *const envp[])
{

        struct pt_regs *regss;
        regss=(current->thread.esp0 - sizeof(struct pt_regs));;
        printk(KERN_INFO"=== %s  ===\n",filename);
        printk(KERN_INFO"saved eip: %x\n",regss->eip);
        printk(KERN_INFO"==========================\n");

        return my_execve(filename,(const char**)argv,(const char**)envp);
}


unsigned long *sys_call_table;

int
init_module(void)
{
        unsigned long *ptr;
        unsigned long arr[4];
        int i;


        ptr=(unsigned long *)((init_mm.end_code + 4) & 0xfffffffc);

        while((unsigned long)ptr < (unsigned long)init_mm.end_data)
        {
                if (*ptr == (unsigned long *)sys_close)
                {

                        printk(KERN_INFO"================\n");
                        printk(KERN_INFO"Founded at %x\n", ptr);
                        printk(KERN_INFO"================\n");
                        for(i=0;i<4;i++)
                        {
                                arr[i]=*(ptr+i);

                                arr[i]=(arr[i] >> 16) & 0x0000ffff;
                        }
                        if(arr[0] != arr[2] || arr[1] != arr[3])
                        {
                                sys_call_table=(ptr-__NR_close);
                                break;
                        }

                }
                ptr++   ;
        }

        printk(KERN_INFO"sys_call_table base found at: %x\n",sys_call_table);
        printk(KERN_INFO"Starting patching!\n");

       original_call = sys_call_table[__NR_execve];
       sys_call_table[__NR_myexecve] = original_call;
       sys_call_table[__NR_execve] = our_sys_execve;



        printk(KERN_INFO"Patched succefully!\n");

out_error:
                return 0;
}

void
cleanup_module(void)
{
        sys_call_table[__NR_execve]=original_call;
}
